SystemOrganization addCategory: #'MC2-Export-Chunk'!

MDElementHandler subclass: #MDChunkHandler
	instanceVariableNames: 'exporter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Export-Chunk'!

!MDChunkHandler class methodsFor: 'instance creation' stamp: 'cwp 10/17/2009 22:40'!
exporter: aChunkExporter
	^ self basicNew initializeWithExporter: aChunkExporter! !

!MDChunkHandler methodsFor: 'smalltalk' stamp: 'cwp 10/17/2009 22:44'!
handleClass: anElement
	^ exporter addChunk: (MDClassChunk forElement: anElement)! !

!MDChunkHandler methodsFor: 'smalltalk' stamp: 'cwp 10/17/2009 22:41'!
handleClassComment: anElement
	^ exporter addChunk: (MDClassCommentChunk forElement: anElement)! !

!MDChunkHandler methodsFor: 'smalltalk' stamp: 'cwp 10/17/2009 22:45'!
handleClassInstVar: anElement
	^ exporter addChunk: (MDClassInstVarChunk forElement: anElement)! !

!MDChunkHandler methodsFor: 'smalltalk' stamp: 'cwp 10/17/2009 22:46'!
handleClassVar: anElement
	^ exporter addChunk: (MDClassVarChunk forElement: anElement)! !

!MDChunkHandler methodsFor: 'smalltalk' stamp: 'cwp 10/17/2009 22:46'!
handleInstVar: anElement
	^ exporter addChunk: (MDInstVarChunk forElement: anElement)! !

!MDChunkHandler methodsFor: 'smalltalk' stamp: 'cwp 10/17/2009 22:47'!
handleMethod: anElement
	^ exporter addChunk: (MDMethodChunk forElement: anElement)! !

!MDChunkHandler methodsFor: 'smalltalk' stamp: 'cwp 10/17/2009 22:47'!
handlePoolImport: anElement
	^ exporter addChunk: (MDPoolImportChunk forElement: anElement)! !

!MDChunkHandler methodsFor: 'initialize-release' stamp: 'cwp 10/17/2009 22:40'!
initializeWithExporter: anExporter
	self initialize.
	exporter := anExporter! !

MDObject subclass: #MDChunk
	instanceVariableNames: 'element properties invisible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Export-Chunk'!

!MDChunk class methodsFor: 'as yet unclassified' stamp: 'cwp 3/25/2008 22:21'!
forElement: anElement
	^ self new setElement: anElement! !

!MDChunk methodsFor: 'accessing' stamp: 'cwp 4/27/2008 00:29'!
beInvisible
	invisible := true! !

!MDChunk methodsFor: 'accessing' stamp: 'cwp 5/2/2008 21:35'!
element
	^ element! !

!MDChunk methodsFor: 'operations' stamp: 'cwp 5/3/2008 00:16'!
hasSuperclass: aSymbol
	^ false! !

!MDChunk methodsFor: 'accessing' stamp: 'cwp 4/27/2008 00:29'!
isRemoval
	^ properties isNil! !

!MDChunk methodsFor: 'operations' stamp: 'cwp 5/3/2008 00:15'!
isSuperOf: aChunk
	^ false! !

!MDChunk methodsFor: 'operations' stamp: 'cwp 5/2/2008 21:43'!
joinSectionIn: aDictionary 
	| section |
	section := aDictionary 
		at: element theClassName
		ifAbsentPut: [ MDFileOutSection new ].
	section addChunk: self! !

!MDChunk methodsFor: 'operations' stamp: 'cwp 4/27/2008 00:06'!
load: aPropertyDictionary
	properties := aPropertyDictionary.
	! !

!MDChunk methodsFor: 'accessing' stamp: 'cwp 5/20/2008 22:41'!
printSortKeyOn: stream 
	^ stream
		nextPut: self typeChar;
		nextPut: $!!;
		nextPutAll: self sortOrdinal! !

!MDChunk methodsFor: 'operations' stamp: 'cwp 4/26/2008 23:50'!
reactToClass: aChunk
	(element theClassName = aChunk name and: [aChunk isRemoval])
		ifTrue: [self beInvisible].
	^ aChunk! !

!MDChunk methodsFor: 'operations' stamp: 'cwp 4/27/2008 00:05'!
remove
	properties := nil! !

!MDChunk methodsFor: 'initialize-release' stamp: 'cwp 4/27/2008 00:29'!
setElement: anElement
	invisible := false.
	element := anElement.! !

!MDChunk methodsFor: 'accessing' stamp: 'cwp 5/20/2008 22:38'!
sortKey
	^ String streamContents: [ :stream | self printSortKeyOn: stream ]! !

!MDChunk methodsFor: 'accessing' stamp: 'cwp 5/20/2008 22:41'!
sortOrdinal
	^ element name! !

!MDChunk methodsFor: 'accessing' stamp: 'cwp 11/18/2008 20:00'!
theClassName
	^ element theClassName! !

!MDChunk methodsFor: 'writing' stamp: 'cwp 5/19/2008 00:29'!
writeInitializerOn: aStream
	! !

!MDChunk methodsFor: 'writing' stamp: 'cwp 4/27/2008 00:31'!
writeOn: aStream
	invisible ifFalse:
		[properties
			ifNil: [self writeRemovalOn: aStream]
			ifNotNil: [self writeDefinitionOn: aStream]]! !

!MDChunk methodsFor: 'writing' stamp: 'cwp 8/12/2008 20:28'!
writeStampOn: aStream 
	((properties includesKey: #initials) and: [ properties includesKey: #timeStamp ]) ifTrue: 
		[ aStream
			nextPutAll: ''' stamp: ''';
			nextPutAll: properties initials;
			space.
		properties timeStamp printer 
			printOn: aStream
			format: '%l/%e/%Y %H:%M' ]! !

MDChunk subclass: #MDClassChunk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Export-Chunk'!

!MDClassChunk class methodsFor: 'as yet unclassified' stamp: 'cwp 3/25/2008 00:19'!
forElement: anElement
	^ self new setElement: anElement! !

!MDClassChunk methodsFor: 'writing' stamp: 'cwp 5/22/2008 00:11'!
formatKeyword
	| format |
	format := properties format.
	format = #normal ifTrue: [^ 'subclass:'].
	format = #bytes ifTrue: [^ 'variableByteSubclass:'].
	format = #variable ifTrue: [^ 'variableSubclass:'].
	format = #words ifTrue: [^ 'variableWordSubclass:'].
	format = #weak ifTrue: [^ 'weakSubclass:'].
	self error: 'Unrecognized format'! !

!MDClassChunk methodsFor: 'harmonizing' stamp: 'cwp 5/19/2008 01:09'!
hasSuperclass: aSymbol
	^ properties
		ifNil: [false]
		ifNotNil: [properties superclassName = aSymbol]! !

!MDClassChunk methodsFor: 'harmonizing' stamp: 'cwp 5/2/2008 23:00'!
isSuperOf: aChunk
	^ aChunk hasSuperclass: element theClassName! !

!MDClassChunk methodsFor: 'harmonizing' stamp: 'cwp 4/26/2008 20:33'!
name
	^ element theClassName! !

!MDClassChunk methodsFor: 'harmonizing' stamp: 'cwp 4/26/2008 20:32'!
reactToClass: aSymbol
	^ self! !

!MDClassChunk methodsFor: 'harmonizing' stamp: 'cwp 3/30/2008 23:48'!
typeChar
	^ $a! !

!MDClassChunk methodsFor: 'writing' stamp: 'cwp 3/28/2008 00:17'!
writeDefinitionOn: aStream
	aStream 
		nextPutAll: properties superclassName;
		space;
		nextPutAll: self formatKeyword;
		space;
		print: element theClassName;
		crtab;
		nextPutAll: 'instanceVariableNames: ''''';
		crtab;
		nextPutAll: 'classVariableNames: ''''';
		crtab;
		nextPutAll: 'poolDictionaries: ''''';
		crtab;
		nextPutAll: 'category: ';
		nextPut: $';
		nextPutAll: properties category;
		nextPut: $';
		nextPut: $!!;
		cr! !

!MDClassChunk methodsFor: 'writing' stamp: 'cwp 3/28/2008 00:18'!
writeRemovalOn: aStream
	aStream 
		nextPutAll: 'Smalltalk removeClassNamed: #';
		nextPutAll: element theClassName;
		nextPut: $!!;
		cr! !

MDChunk subclass: #MDClassCommentChunk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Export-Chunk'!

!MDClassCommentChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:48'!
typeChar
	^ $b! !

!MDClassCommentChunk methodsFor: 'as yet unclassified' stamp: 'cwp 7/2/2008 23:06'!
writeDefinitionOn: aStream
	aStream
		nextPut: $!!;
		nextPutAll: element theClassName;
		nextPutAll: ' commentStamp: ''';
		nextPutAll: (properties initials ifNil: ['<unknown author>']);
		space.
	properties timeStamp ifNotNilDo:
		[:stamp | stamp printer printOn: aStream format: '%l/%e/%Y %H:%M'].
	aStream
		nextPutAll: ''' prior: 0!!';
		cr.
	properties text do:
		[:ch |
		aStream nextPut: ch.
		ch = $!! ifTrue: [aStream nextPut: $!!]].
	aStream
		nextPut: $!!;
		cr! !

!MDClassCommentChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 23:37'!
writeRemovalOn: aStream
	aStream
		nextPut: $!!;
		nextPutAll: element theClassName;
		nextPutAll: ' classComment: nil stamp: nil!!';
		cr! !

MDChunk subclass: #MDMethodChunk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Export-Chunk'!

!MDMethodChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:55'!
typeChar
	^ element classIsMeta
		ifTrue: [$h]
		ifFalse: [$f]! !

!MDMethodChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 01:08'!
writeDefinitionOn: aStream 
	aStream
		nextPut: $!!;
		nextPutAll: element theClassName.
	element classIsMeta ifTrue: [ aStream nextPutAll: ' class' ].
	aStream
		space;
		nextPutAll: 'methodsFor: ''';
		nextPutAll: properties category.
	self writeStampOn: aStream.
	aStream
		nextPutAll: '''!!';
		cr.
	properties source do:
		[:ch |
		aStream nextPut: ch.
		ch = $!! ifTrue: [aStream nextPut: $!!]].
	aStream
		nextPutAll: '!! !!';
		cr! !

!MDMethodChunk methodsFor: 'as yet unclassified' stamp: 'cwp 5/19/2008 00:40'!
writeInitializerOn: aStream
	(element classIsMeta and: [element selector = #initialize]) ifTrue:
		[aStream 
			nextPutAll: element theClassName;
			space;
			nextPutAll: 'initialize!!';
			cr;
			cr]! !

!MDMethodChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/31/2008 00:03'!
writeRemovalOn: aStream
	aStream nextPutAll: element theClassName.
	element classIsMeta ifTrue: [aStream nextPutAll: ' class'].
	aStream 
		nextPutAll: ' removeSelector: #';
		nextPutAll: element selector;
		nextPut: $!!;
		cr! !

MDChunk subclass: #MDNullChunk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Export-Chunk'!

!MDNullChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:39'!
sortKey
	^ ''! !

!MDNullChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 00:10'!
writeOn: aStream! !

MDChunk subclass: #MDVariableChunk
	instanceVariableNames: 'independent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Export-Chunk'!

MDVariableChunk subclass: #MDClassInstVarChunk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Export-Chunk'!

!MDClassInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 00:20'!
classReference
	^ element theClassName, ' class'! !

!MDClassInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 22:29'!
definitionSelector
	^ 'class addInstVarName:'! !

!MDClassInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 00:15'!
listSelector
	^ 'instVarNames'! !

!MDClassInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 22:35'!
removalSelector
	^ 'class removeInstVarName:'! !

!MDClassInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 5/20/2008 23:02'!
sortOrdinal
	^ properties index printString! !

!MDClassInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:52'!
typeChar
	^ $g! !

MDVariableChunk subclass: #MDClassVarChunk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Export-Chunk'!

!MDClassVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 22:14'!
definitionSelector
	^ 'addClassVarName:'! !

!MDClassVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 00:21'!
listSelector
	^ 'classVarNames'! !

!MDClassVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 22:15'!
removalSelector
	^ 'removeClassVarName:'! !

!MDClassVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:51'!
typeChar
	^ $d! !

MDVariableChunk subclass: #MDInstVarChunk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Export-Chunk'!

!MDInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 22:15'!
definitionSelector
	^ 'addInstVarName:'! !

!MDInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 00:22'!
listSelector
	^ 'instVarNames'! !

!MDInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 22:16'!
removalSelector
	^ 'removeInstVarName:'! !

!MDInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 5/20/2008 22:50'!
sortOrdinal
	^ properties index printString! !

!MDInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:48'!
typeChar
	^ $c! !

MDVariableChunk subclass: #MDPoolImportChunk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Export-Chunk'!

!MDPoolImportChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 23:48'!
definitionSelector
	^ 'addSharedPool:'! !

!MDPoolImportChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 23:48'!
listSelector
	^ 'sharedPools'! !

!MDPoolImportChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 23:55'!
quote
	^ ''! !

!MDPoolImportChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:28'!
removalSelector
	^ 'removeSharedPool:'! !

!MDPoolImportChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:52'!
typeChar
	^ $e! !

!MDVariableChunk methodsFor: 'accessing' stamp: 'cwp 4/3/2008 22:26'!
beDependent
	independent := false! !

!MDVariableChunk methodsFor: 'accessing' stamp: 'cwp 4/3/2008 22:26'!
beIndependent
	independent := true! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:31'!
classReference
	^ element theClassName! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:30'!
conditional
	^ properties
		ifNil: ['ifTrue:']
		ifNotNil: ['ifFalse:']! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:24'!
definitionSelector
	self subclassResponsibility! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:24'!
listSelector
	self subclassResponsibility! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:30'!
quote
	^ ''''! !

!MDVariableChunk methodsFor: 'accessing' stamp: 'cwp 4/27/2008 00:40'!
reactToClass: aChunk
	element theClassName = aChunk name ifTrue: 
		[aChunk isRemoval
			ifTrue: [self beInvisible]
			ifFalse: [self beDependent]].
	^ aChunk! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:24'!
removalSelector
	self subclassResponsibility! !

!MDVariableChunk methodsFor: 'initialize-release' stamp: 'cwp 4/3/2008 22:28'!
setElement: anElement
	super setElement: anElement.
	independent := true! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:24'!
typeChar
	self subclassResponsibility! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:30'!
writeBasicDefinitionOn: aStream 
	aStream
		nextPutAll: element theClassName;
		space;
		nextPutAll: self definitionSelector;
		space;
		nextPutAll: self quote;
		nextPutAll: element name;
		nextPutAll: self quote! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:30'!
writeBasicRemovalOn: aStream 
	aStream
		nextPutAll: element theClassName;
		space;
		nextPutAll: self removalSelector;
		space;
		nextPutAll: self quote;
		nextPutAll: element name;
		nextPutAll: self quote! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:30'!
writeClassCheckOn: aStream with: aBlock
	independent ifFalse: aBlock ifTrue: 
		[aStream
			nextPutAll: '(Smalltalk hasClassNamed: #';
			nextPutAll: element theClassName;
			nextPutAll: ') ifTrue:';
			crtab;
			nextPut: $[.
		aBlock value.
		aStream
			nextPut: $]].
	aStream 
		nextPut: $!!; 
		cr! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:30'!
writeDefinitionOn: aStream 
	self 
		writeClassCheckOn: aStream
		with: 
			[ self 
				writeGuardOn: aStream
				with: [ self writeBasicDefinitionOn: aStream ] ]! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:30'!
writeGuardOn: aStream with: aBlock
	aStream
		nextPut: $(;
		nextPutAll: self classReference;
		space;
		nextPutAll: self listSelector;
		nextPutAll: ' includes: ';
		nextPutAll: self quote;
		nextPutAll: element name;
		nextPutAll: self quote;
		nextPutAll: ') ';
		nextPutAll: self conditional;
		crtab.
	independent ifTrue: [aStream tab].
	aStream nextPut: $[.
	aBlock value.
	aStream nextPut: $]! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:29'!
writeRemovalOn: aStream 
	self 
		writeClassCheckOn: aStream
		with: 
			[ self 
				writeGuardOn: aStream
				with: [ self writeBasicRemovalOn: aStream ] ]! !

MDObject subclass: #MDFileOutExporter
	instanceVariableNames: 'stream sections preamble'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Export-Chunk'!

!MDFileOutExporter class methodsFor: 'as yet unclassified' stamp: 'cwp 3/24/2008 23:16'!
on: aStream
	^ self new setStream: aStream! !

!MDFileOutExporter methodsFor: 'as yet unclassified' stamp: 'cwp 10/17/2009 22:39'!
adapt: anElement
	^ anElement handleWith: (MDChunkHandler exporter: self)! !

!MDFileOutExporter methodsFor: 'adapting' stamp: 'cwp 5/2/2008 21:23'!
adaptorForClassCommentElement: anElement 
	^ self addChunk: (MDClassCommentChunk forElement: anElement)! !

!MDFileOutExporter methodsFor: 'adapting' stamp: 'cwp 5/2/2008 21:23'!
adaptorForClassElement: anElement 
	^ self addChunk: (MDClassChunk forElement: anElement)! !

!MDFileOutExporter methodsFor: 'adapting' stamp: 'cwp 5/2/2008 21:23'!
adaptorForClassInstVarElement: anElement 
	^ self addChunk: (MDClassInstVarChunk forElement: anElement)! !

!MDFileOutExporter methodsFor: 'adapting' stamp: 'cwp 5/2/2008 21:23'!
adaptorForClassVarElement: anElement 
	^ self addChunk: (MDClassVarChunk forElement: anElement)! !

!MDFileOutExporter methodsFor: 'adapting' stamp: 'cwp 5/2/2008 21:23'!
adaptorForInstVarElement: anElement 
	^ self addChunk: (MDInstVarChunk forElement: anElement)! !

!MDFileOutExporter methodsFor: 'adapting' stamp: 'cwp 5/2/2008 21:23'!
adaptorForMethodElement: anElement 
	^ self addChunk: (MDMethodChunk forElement: anElement)! !

!MDFileOutExporter methodsFor: 'adapting' stamp: 'cwp 5/2/2008 21:23'!
adaptorForPoolImportElement: anElement 
	^ self addChunk: (MDPoolImportChunk forElement: anElement)! !

!MDFileOutExporter methodsFor: 'exporting' stamp: 'cwp 5/2/2008 21:43'!
addChunk: aChunk 
	aChunk joinSectionIn: sections.
	^ aChunk! !

!MDFileOutExporter methodsFor: 'exporting' stamp: 'cwp 5/2/2008 22:35'!
addMemo: aMemo 
	preamble := MDMemoChunk on: aMemo.! !

!MDFileOutExporter methodsFor: 'exporting' stamp: 'cwp 5/2/2008 21:19'!
addVersion: aVersion
	aVersion variant loadInto: self! !

!MDFileOutExporter methodsFor: 'exporting' stamp: 'cwp 5/2/2008 21:19'!
export: aMemo from: aRepository
	| snapshot |
	self addMemo: aMemo.
	snapshot := aRepository get: aMemo reference.
	snapshot contents do:
		[:ea | self addVersion: (aRepository get: ea)].
	self harmonize.
	self flush! !

!MDFileOutExporter methodsFor: 'exporting' stamp: 'cwp 5/19/2008 00:44'!
flush
	preamble ifNotNil: 
		[preamble writeOn: stream.
		stream cr].
	sections 
		do:	[:ea | 
			ea writeOn: stream. 
			stream cr].
	sections do: [:ea | ea writeInitializerOn: stream].
	stream flush! !

!MDFileOutExporter methodsFor: 'exporting' stamp: 'cwp 5/2/2008 22:46'!
harmonize
	sections do: [:ea | ea harmonize].
	sections do: 
		[:outer | 
		sections do: 
			[:inner | 
			outer noteSection: inner]].
	sections := sections asSortedCollection.! !

!MDFileOutExporter methodsFor: 'initialize-release' stamp: 'cwp 5/2/2008 21:30'!
setStream: aStream
	stream := aStream.
	sections := Dictionary new.! !

MDObject subclass: #MDFileOutSection
	instanceVariableNames: 'chunks superSection depth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Export-Chunk'!

!MDFileOutSection class methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2008 18:49'!
new
	^ self basicNew initialize! !

!MDFileOutSection methodsFor: 'as yet unclassified' stamp: 'cwp 10/13/2008 16:22'!
<= other
	^ self isSharedPool = other isSharedPool
		ifFalse: [self isSharedPool]
		ifTrue: 
			[self depth = other depth
				ifTrue: [self theClassName <= other theClassName]
				ifFalse: [self depth < other depth]]
! !

!MDFileOutSection methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2008 21:29'!
addChunk: aChunk
	chunks add: aChunk! !

!MDFileOutSection methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2008 22:30'!
classChunk
	^ chunks first! !

!MDFileOutSection methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2008 23:01'!
depth
	^ depth ifNil:
		[depth := superSection 
			ifNil: [1]
			ifNotNil: [superSection depth + 1]]! !

!MDFileOutSection methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2008 21:31'!
harmonize
	| class |
	chunks := chunks asSortedCollection: [ :a :b | a sortKey <= b sortKey ].
	class := nil.
	chunks do: [ :chunk | class := chunk reactToClass: class ]! !

!MDFileOutSection methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2008 21:29'!
initialize
	chunks := Set new! !

!MDFileOutSection methodsFor: 'as yet unclassified' stamp: 'cwp 10/13/2008 16:32'!
isSharedPool
	^ self classChunk hasSuperclass: #SharedPool! !

!MDFileOutSection methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2008 22:30'!
noteSection: other
	(other classChunk isSuperOf: self classChunk) ifTrue:
		[superSection := other]! !

!MDFileOutSection methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2008 20:00'!
theClassName
	^ chunks first theClassName! !

!MDFileOutSection methodsFor: 'as yet unclassified' stamp: 'cwp 5/19/2008 00:39'!
writeInitializerOn: aStream
	chunks do: [:ea | ea writeInitializerOn: aStream]
		! !

!MDFileOutSection methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2008 21:34'!
writeOn: aStream
	chunks
		do: [:ea | ea writeOn: aStream]
		separatedBy: [aStream cr]! !

MDObject subclass: #MDMemoChunk
	instanceVariableNames: 'memo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Export-Chunk'!

!MDMemoChunk class methodsFor: 'as yet unclassified' stamp: 'cwp 3/24/2008 23:19'!
on: aMemo
	^ self new setMemo: aMemo! !

!MDMemoChunk methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
setMemo: aMemo
	memo := aMemo! !

!MDMemoChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 01:00'!
writeOn: aStream
	aStream 
		nextPut: $";
		nextPutAll: memo name;
		cr.
	memo description do:
		[:ch | 
		aStream nextPut: ch. 
		ch = $" ifTrue: [aStream nextPut: $"].
		ch = $!! ifTrue: [aStream nextPut: $!!]].
	aStream
		nextPutAll: '"!!';
		cr! !
